Index: TVHomeNavigator.cs
===================================================================
--- TVHomeNavigator.cs	(revision 27982)
+++ TVHomeNavigator.cs	(working copy)
@@ -560,41 +560,46 @@
     /// <param name="useZapDelay">If true, the configured zap delay is used. Otherwise it zaps immediately.</param>
     public void ZapToChannelNumber(int channelNr, bool useZapDelay)
     {
-      IList<GroupMap> channels = CurrentGroup.ReferringGroupMap();
-      if (channelNr >= 0)
-      {
-        Log.Debug("channels.Count {0}", channels.Count);
 
-        bool found = false;
-        int iCounter = 0;
-        Channel chan;
-        while (iCounter < channels.Count && found == false)
+        foreach (ChannelGroup Current in m_groups)
         {
-          chan = ((GroupMap)channels[iCounter]).ReferencedChannel();
-
-          Log.Debug("chan {0}", chan.DisplayName);
-          if (chan.VisibleInGuide)
-          {
-            foreach (TuningDetail detail in chan.ReferringTuningDetail())
+            IList<GroupMap> channels = Current.ReferringGroupMap();
+            if (channelNr >= 0)
             {
-              Log.Debug("detail nr {0} id{1}", detail.ChannelNumber, detail.IdChannel);
+                Log.Debug("channels.Count {0} Channel Nr {1}", channels.Count, channelNr);
 
-              if (detail.ChannelNumber == channelNr)
-              {
-                Log.Debug("find channel: iCounter {0}, detail.ChannelNumber {1}, detail.name {2}, channels.Count {3}",
-                          iCounter, detail.ChannelNumber, detail.Name, channels.Count);
-                found = true;
-                ZapToChannel(iCounter + 1, useZapDelay);
-              }
+                bool found = false;
+                int iCounter = 0;
+                Channel chan;
+                while (iCounter < channels.Count && found == false)
+                {
+                    chan = ((GroupMap)channels[iCounter]).ReferencedChannel();
+
+                    Log.Debug("chan {0}", chan.DisplayName);
+                    if (chan.VisibleInGuide)
+                    {
+                        foreach (TuningDetail detail in chan.ReferringTuningDetail())
+                        {
+                            Log.Debug("detail nr {0} id{1}", detail.ChannelNumber, detail.IdChannel);
+
+                            if (detail.ChannelNumber == channelNr)
+                            {
+                                Log.Debug("find channel: iCounter {0}, detail.ChannelNumber {1}, detail.name {2}, channels.Count {3}",
+                                          iCounter, detail.ChannelNumber, detail.Name, channels.Count);
+                                found = true;
+                                SetCurrentGroup(Current.GroupName);
+                                ZapToChannel(iCounter + 1, useZapDelay);
+                            }
+                        }
+                    }
+                    iCounter++;
+                }
+                if (found)
+                {
+                    m_zapChannelNr = channelNr;
+                }
             }
-          }
-          iCounter++;
         }
-        if (found)
-        {
-          m_zapChannelNr = channelNr;
-        }
-      }
     }
 
     /// <summary>
